'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AsyncLoader = function (_Component) {
  _inherits(AsyncLoader, _Component);

  function AsyncLoader() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AsyncLoader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AsyncLoader.__proto__ || Object.getPrototypeOf(AsyncLoader)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      loadState: 1,
      CurrentComponent: null,
      error: null
    }, _this.componentDidMount = function () {
      _this.load(_this.props);
    }, _this.componentDidUpdate = function (prevProps) {
      if (_this.props.loadKey !== prevProps.loadKey) {
        _this.load(_this.props);
      }
    }, _this.load = function (props) {
      _this.setState({
        loadState: 1,
        CurrentComponent: null
      });
      props.load(function (e, CurrentComponent) {
        if (e) {
          return _this.setState({
            loadState: 3,
            error: e
          });
        }
        _this.setState({
          loadState: 2,
          // handle both es module and commonjs
          CurrentComponent: CurrentComponent.default ? CurrentComponent.default : CurrentComponent
        });
      });
    }, _this.renderSuccess = function (CurrentComponent) {
      var pickedProps = (0, _omit2.default)(_this.props, ['load', 'loadKey']);
      return _react2.default.createElement(CurrentComponent, pickedProps);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(AsyncLoader, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          renderLoading = _props.renderLoading,
          renderError = _props.renderError;
      var _state = this.state,
          loadState = _state.loadState,
          CurrentComponent = _state.CurrentComponent,
          error = _state.error;


      if (typeof this.props.children === 'function') {
        return this.props.children(loadState, CurrentComponent, error);
      }

      var renderSuccess = this.props.renderSuccess || this.renderSuccess;

      return loadState === 1 ? renderLoading() : loadState === 2 ? renderSuccess(CurrentComponent) : renderError(error);
    }
  }]);

  return AsyncLoader;
}(_react.Component);

AsyncLoader.defaultProps = {
  loadKey: '',
  load: function load() {},
  renderLoading: function renderLoading() {
    return _react2.default.createElement(
      'div',
      null,
      'Loading...'
    );
  },
  renderError: function renderError(err) {
    console.error(err);
    return _react2.default.createElement(
      'div',
      { style: { backgroundColor: '#F22', position: 'fixed', top: 0, right: 0, left: 0, bottom: 0 } },
      _react2.default.createElement(
        'pre',
        { style: { color: '#FFF' } },
        err.stack || err.message || err
      )
    );
  }

};
exports.default = AsyncLoader;